{#
 # This file is part of the DATAtourisme project.
 # @author Conjecto <contact@conjecto.com>
 # 2022
 # SPDX-License-Identifier: GPL-3.0-or-later
 # For the full copyright and license information, please view the LICENSE file that was distributed with this source code.
 #}

{% extends 'flux/detail.html.twig' %}
{% block subcontent %}
    <div class="flux-report row">
        <div class="col-lg-7 flux-last-process">
            {% include 'flux/detail/report/' ~ flux.lastActiveProcess.status ~ '.html.twig' %}
        </div>
        <div class="col-lg-5 flux-stats widget-stats">
            <div class="box-header with-border">
                <div class="btn-group btn-group-xs pull-right" role="group" aria-label="...">
                    <a href="#donut-wrapper" class="btn btn-default active" data-toggle="tab">Répartition</a>
                    <a href="#line-wrapper" class="btn btn-default" data-toggle="tab">Evolution</a>
                </div>
                <h3 class="box-title">Statistiques du flux : <strong>{{ poi_published | number_format }}</strong> POI</h3>
            </div>
            <div class="box-body">
                <div class="tab-content">
                    <div class="tab-pane fade in active" id="donut-wrapper">
                        {% if resources_by_poi %}
                            <div id="donut" style="max-height: 250px;"
                                 data-morris-donut='[
                        {% for poi in resources_by_poi %}
                            { "label": "{{ poi.type }}", "value": {{ poi.nb_poi }} }{{ loop.last ? '' : ',' }}
                        {% endfor %}
                    ]'
                            ></div>
                            <div id="donut-legend" class="p-10 p-b-0"></div>
                        {% else %}
                            <div class="blankslate blankslate-spacious">
                                <h4>Il n'y a aucun POI associé à ce flux</h4>
                            </div>
                        {% endif %}

                    </div>
                    <div class="tab-pane fade in" id="line-wrapper">
                        {% if flux.processes|length %}
                            <div id="line" style="max-height: 250px;"
                                 data-morris-line='[
                                    {% spaceless %}
                                    {% set comma = 1 %}
                                    {% for cprocess in flux.getOneProcessByDay %}
                                        {% if date(cprocess.createdAt) > date('-10days') %}
                                            {{- comma==1 ? '' : ',' -}}{%- set comma = 0 -%}
                                            { "date": "{{ cprocess.createdAt | date("Y-m-d") }}", "value": {{ cprocess.nbPublishedRdfResources }} }
                                        {% endif %}
                                    {% endfor %}
                                    {% endspaceless %}
                                ]'
                            ></div>
                        {% else %}
                            <div class="blankslate blankslate-spacious">
                                <h4>Il n'y a aucune statistique d'évolution associée à ce flux</h4>
                            </div>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}


{% block javascripts %}
<script>
    var initialStatus = "{{ flux.lastActiveProcess.status }}";
    $(function() {
        var interval = initialStatus == "running" ? 500 : 3000;
        function update() {
            $.get("{{ url('flux.status', {id: flux.id}) }}", function (data) {
                if(data.status != initialStatus) {
                    window.location.reload();
                    return;
                }
                if(data.status == "running") {
                    var container = $(".list-log");
                    var ul = $(".list-log ul");
                    var scrollToBottom = ul.height() > 0 && (container.scrollTop() + container.height()) >= (ul.height() - 10);

                    // update log
                    ul.empty();
                    $.each(data.log, function(i, line) {
                        $("<li></li>").html(line).appendTo(ul);
                    });

                    if(scrollToBottom) {
                        container.scrollTop(ul.height());
                    }

                    //update progress
                    var progression = data.progression + "%";
                    $(".progress-bar").css("width", progression);
                    $(".progress-bar span").html(progression);
                }
            }).always(function() {
                setTimeout(update, interval);
            });
        }
        update();
    });
</script>
{% endblock %}
